chiark / gitweb /
841937510b6f1666cafb52dc43cc490cd102d001
[dgit.git] / git-debpush
1 #!/bin/bash
2
3 # git-debpush -- create & push a git tag with metadata for an ftp-master upload
4 #
5 # Copyright (C) 2019 Sean Whitton
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 set -e$DGIT_TEST_DEBPUSH_DEBUG
21 set -o pipefail
22
23 # DESIGN PRINCIPLES
24 #
25 # - do not invoke dgit, do anything involving any tarballs, no network
26 #   access except `git push` right at the end
27 #
28 # - do not look at the working tree, like `git push` `git tag`
29 #
30 # - we are always in split brain mode, because that fits this workflow,
31 #   and avoids pushes failing just because dgit in the intermediary
32 #   service wants to append commits
33 #
34 # - if there is no previous tag created by this script, require a quilt
35 #   mode; if there is a previous tag, and no quilt mode provided, assume
36 #   same quilt mode as in previous tag created by this script
37
38 # **** Helper functions and variables ****
39
40 us="$(basename $0)"
41 git_playtree_setup=git-playtree-setup ###substituted###
42 git_playtree_setup=${DEBPUSH_GIT_PLAYTREE_SETUP-$git_playtree_setup}
43
44 cleanup() {
45     if [ -d "$temp" ]; then
46         rm -rf "$temp"
47     fi
48 }
49
50 fail () {
51     echo >&2 "$us: $*";
52     exit 127;
53 }
54
55 badusage () {
56     fail "bad usage: $*";
57 }
58
59 get_file_from_ref () {
60     local path=$1
61
62     if git ls-tree --name-only -r "$branch" \
63             | grep -Eq "^$path$"; then
64         git cat-file blob $branch:$path
65     fi
66 }
67
68 failed_check=false
69 fail_check () {
70     local check=$1; shift
71     local check_is_forced=false
72
73     case ",$force," in
74         *",$check,"*) check_is_forced=true ;;
75     esac
76     if $force_all || $check_is_forced; then
77         echo >&2 "$us: warning: $* ('$check' check)"
78     else
79         echo >&2 "$us: $* ('$check' check)"
80         failed_check=true
81     fi
82 }
83
84 fail_check_upstream_nonidentical () {
85     fail_check upstream-nonidentical \
86  "the upstream source in tag $upstream_tag is not identical to the upstream source in $branch"
87 }
88
89 find_last_tag () {
90     local prefix=$1
91
92     set +o pipefail             # perl will SIGPIPE git-log(1) here
93     git log --pretty=format:'%D' --decorate=full "$branch" \
94         | perl -wne 'use Dpkg::Version;
95             @pieces = split /, /, $_;
96             @debian_tag_vs = sort { version_compare($b, $a) }
97                 map { m|tag: refs/tags/'"$prefix"'(.+)| ? $1 : () } @pieces;
98             if (@debian_tag_vs) { print "'"$prefix"'$debian_tag_vs[0]\n"; exit }'
99     set -o pipefail
100 }
101
102 check_treesame () {
103     local first=$1
104     local second=$2
105     shift 2
106
107     set +e
108     git diff --quiet --exit-code "$first".."$second" -- . "$@"
109     git_diff_rc=$?
110     set -e
111
112     # show the user what the difference was
113     if [ $git_diff_rc = 1 ]; then
114         git diff --compact-summary "$first".."$second" -- . "$@"
115     fi
116
117     if [ $git_diff_rc -le 1 ]; then
118         return $git_diff_rc
119     else
120         fail "'git diff' exited with unexpected code $git_diff_rc"
121     fi
122 }
123
124 check_patches_apply () {
125     local should_match_branch="$1"
126
127     local playground="$(git rev-parse --git-dir)/gdp"
128     local playtree="$playground/apply-patches"
129     local git_apply_rc=0
130
131     rm -rf "$playground"
132     mkdir -p "$playtree"
133     local pwd="$(pwd)"
134     cd "$playtree"
135     "$git_playtree_setup" .
136
137     # checking out the upstream source and then d/patches on top
138     # ensures this check will work for a variety of quilt modes
139     git checkout -b upstream "$upstream_committish"
140     git checkout "$branch_commit" -- debian
141
142     if [ -s "debian/patches/series" ]; then
143         while read patch; do
144             shopt -s extglob; patch="${patch%%?( )#*}"; shopt -u extglob
145             if [ -z "$patch" ]; then continue; fi
146             set +e
147             git apply --index "debian/patches/$patch"
148             git_apply_rc=$?
149             set -e
150             if ! [ $git_apply_rc = 0 ]; then
151                 fail_check patches-applicable \
152                            "'git apply' failed to apply patch $patch"
153                 break
154             fi
155         done <debian/patches/series
156
157         if $should_match_branch && [ $git_apply_rc = 0 ]; then
158             git commit -q -a -m"commit result of applying all patches"
159             check_treesame HEAD "$branch_commit" ':!debian' \
160                 || fail_check patches-applicable \
161                               "applying all patches does not yield $branch"
162         fi
163     fi
164
165     cd "$pwd"
166     rm -rf "$playground"
167 }
168
169 # **** Parse command line ****
170
171 getopt=$(getopt -s bash -o 'nfu:' \
172               -l 'no-push,force::,branch:,remote:,distro:,upstream:,quilt:,gbp,dpm,\
173 baredebian,baredebian+git,baredebian+tarball' \
174               -n "$us" -- "$@")
175 eval "set - $getopt"
176 set -e$DGIT_TEST_DEBPUSH_DEBUG
177
178 git_tag_opts=()
179 pushing=true
180 force_all=false
181 force=""
182 distro=debian
183 quilt_mode=""
184 branch="HEAD"
185
186 while true; do
187     case "$1" in
188         '-n'|'--no-push') pushing=false;           shift;   continue ;;
189         '-u')             git_tag_opts+=(-u "$2"); shift 2; continue ;;
190         '-f')             force_all=true;          shift;   continue ;;
191         '--gbp')          quilt_mode='gbp';        shift;   continue ;;
192         '--dpm')          quilt_mode='dpm';        shift;   continue ;;
193         '--branch')       branch=$2;               shift 2; continue ;;
194         '--remote')       remote=$2;               shift 2; continue ;;
195         '--distro')       distro=$2;               shift 2; continue ;;
196         '--quilt')        quilt_mode=$2;           shift 2; continue ;;
197         '--upstream')     upstream_tag=$2;         shift 2; continue ;;
198
199         '--baredebian'|'--baredebian+git')
200             quilt_mode=baredebian;         shift; continue ;;
201         '--baredebian+tarball')
202             fail "--baredebian+tarball quilt mode not supported"
203             ;;
204
205         # we require the long form of the option to skip individual
206         # checks, not permitting `-f check`, to avoid problems if we
207         # later want to introduce positional args
208         '--force')
209             case "$2" in
210                 '')
211                     force_all=true                         ;;
212                 *)
213                     force="$force,$2"                      ;;
214             esac
215             shift 2; continue ;;
216
217         '--') shift; break ;;
218         *) badusage "unknown option $1" ;;
219     esac
220 done
221
222 if [ $# != 0 ]; then
223     badusage 'no positional arguments allowed'
224 fi
225
226 case "$quilt_mode" in
227     linear|auto|smash|nofix|gbp|dpm|unapplied|baredebian|'') ;;
228     baredebian+git) quilt_mode="baredebian" ;;
229     baredebian+tarball) fail "--baredebian+tarball quilt mode not supported" ;;
230     *) badusage "invalid quilt mode: $quilt_mode" ;;
231 esac
232
233 # **** Gather git information ****
234
235 remoteconfigs=()
236 to_push=()
237
238 # Maybe $branch is a symbolic ref.  If so, resolve it
239 branchref="$(git symbolic-ref -q $branch || test $? = 1)"
240 if [ "x$branchref" != "x" ]; then
241    branch="$branchref"
242 fi
243 # If $branch is the name of a branch but it does not start with
244 # 'refs/heads/', prepend 'refs/heads/', so that we can know later
245 # whether we are tagging a branch or some other kind of committish
246 case "$branch" in
247     refs/heads/*) ;;
248     *)
249         branchref="$(git for-each-ref --format='%(objectname)' \
250                          '[r]efs/heads/$branch')"
251         if [ "x$branchref" != "x" ]; then
252             branch="refs/heads/$branch"
253         fi
254         ;;
255 esac
256
257 # If our tag will point at a branch, push that branch, and add its
258 # pushRemote and remote to the things we'll check if the user didn't
259 # supply a remote
260 case "$branch" in
261     refs/heads/*)
262         b=${branch#refs/heads/}
263         to_push+=("$b")
264         remoteconfigs+=( branch.$b.pushRemote branch.$b.remote )
265         ;;
266 esac
267
268 # resolve $branch to a commit
269 branch_commit="$(git rev-parse --verify ${branch}^{commit})"
270
271 # also check, if the branch does not have its own pushRemote or
272 # remote, whether there's a default push remote configured
273 remoteconfigs+=(remote.pushDefault)
274
275 if $pushing && [ "x$remote" = "x" ]; then
276     for c in "${remoteconfigs[@]}"; do
277         remote=$(git config "$c" || test $? = 1)
278         if [ "x$remote" != "x" ]; then break; fi
279     done
280     if [ "x$remote" = "x" ]; then
281         fail "pushing, but could not determine remote, so need --remote="
282     fi
283 fi
284
285 # **** Gather source package information ****
286
287 temp=$(mktemp -d)
288 trap cleanup EXIT
289 mkdir "$temp/debian"
290 git cat-file blob "$branch":debian/changelog >"$temp/debian/changelog"
291 version=$(cd $temp; dpkg-parsechangelog -SVersion)
292 source=$(cd $temp; dpkg-parsechangelog -SSource)
293 target=$(cd $temp; dpkg-parsechangelog -SDistribution)
294 rm -rf "$temp"
295 trap - EXIT
296
297 format="$(get_file_from_ref debian/source/format)"
298 case "$format" in
299     '3.0 (quilt)')  upstream=true ;;
300     '3.0 (native)') upstream=false ;;
301     '1.0'|'')
302         if get_file_from_ref debian/source/options | grep -q '^-sn *$'; then
303             upstream=false
304         elif get_file_from_ref debian/source/options | grep -q '^-sk *$'; then
305             upstream=true
306         else
307             fail 'please see "SOURCE FORMAT 1.0" in git-debpush(1)'
308         fi
309         ;;
310     *)
311         fail "unsupported debian/source/format $format"
312         ;;
313 esac
314
315 # **** Gather git history information ****
316
317 last_debian_tag=$(find_last_tag "debian/")
318 last_archive_tag=$(find_last_tag "archive/debian/")
319
320 upstream_info=""
321 if $upstream; then
322     if [ "x$upstream_tag" = x ]; then
323         upstream_tag=$(
324             set +e
325             git deborig --just-print --version="$version" \
326                            | head -n1
327             ps="${PIPESTATUS[*]}"
328             set -e
329             case "$ps" in
330                 "0 0"|"141 0") ;; # ok or SIGPIPE
331                 *" 0")
332                     echo >&2 \
333  "$us: git-deborig failed; maybe try $us --upstream=TAG"
334                     exit 0
335                     ;;
336                 *) exit 127; # presumably head will have complained
337             esac
338         )
339         if [ "x$upstream_tag" = x ]; then exit 127; fi
340     fi
341     upstream_committish=$(git rev-parse "refs/tags/${upstream_tag}"^{})
342     upstream_info=" upstream-tag=$upstream_tag upstream=$upstream_committish"
343     to_push+=("$upstream_tag")
344 fi
345
346 # **** Useful sanity checks ****
347
348 # ---- UNRELEASED suite
349
350 if [ "$target" = "UNRELEASED" ]; then
351     fail_check unreleased "UNRELEASED changelog"
352 fi
353
354 # ---- Pushing dgit view to maintainer view
355
356 if ! [ "x$last_debian_tag" = "x" ] && ! [ "x$last_archive_tag" = "x" ]; then
357     last_debian_tag_c=$(git rev-parse "$last_debian_tag"^{})
358     last_archive_tag_c=$(git rev-parse "$last_archive_tag"^{})
359     if ! [ "$last_debian_tag_c" = "$last_archive_tag_c" ] \
360             && git merge-base --is-ancestor \
361                    "$last_debian_tag" "$last_archive_tag"; then
362         fail_check dgit-view \
363 "looks like you might be trying to push the dgit view to the maintainer branch?"
364     fi
365 fi
366
367 # ---- Targeting different suite
368
369 if ! [ "x$last_debian_tag" = "x" ]; then
370     temp=$(mktemp -d)
371     trap cleanup EXIT
372     mkdir "$temp/debian"
373     git cat-file blob "$last_debian_tag":debian/changelog >"$temp/debian/changelog"
374     prev_target=$(cd $temp; dpkg-parsechangelog -SDistribution)
375     rm -rf "$temp"
376     trap - EXIT
377
378     if ! [ "$prev_target" = "$target" ] && ! [ "$target" = "UNRELEASED" ]; then
379         fail_check suite \
380 "last upload targeted $prev_target, now targeting $target; might be a mistake?"
381     fi
382 fi
383
384 # ---- Upstream tag is not ancestor of $branch
385
386 if ! [ "x$upstream_tag" = "x" ] \
387         && ! git merge-base --is-ancestor "$upstream_tag" "$branch" \
388         && ! [ "$quilt_mode" = "baredebian" ]; then
389     fail_check upstream-nonancestor \
390  "upstream tag $upstream_tag is not an ancestor of $branch; probably a mistake"
391 fi
392
393 # ---- Quilt mode-specific checks
394
395 case "$quilt_mode" in
396     gbp)
397         check_treesame "$upstream_tag" "$branch" ':!debian' ':!**.gitignore' \
398             || fail_check_upstream_nonidentical
399         check_patches_apply false
400         ;;
401     unapplied)
402         check_treesame "$upstream_tag" "$branch" ':!debian' \
403             || fail_check_upstream_nonidentical
404         check_patches_apply false
405         ;;
406     baredebian)
407         check_patches_apply false
408         ;;
409     dpm|nofix)
410         check_patches_apply true
411         ;;
412 esac
413
414 # ---- Summary
415
416 if $failed_check; then
417     # We don't mention the --force=check options here as those are
418     # mainly for use by scripts, or when you already know what check
419     # is going to fail before you invoke git-debpush.  Keep the
420     # script's terminal output as simple as possible.  No "see the
421     # manpage"!
422     fail "some check(s) failed; you can pass --force to ignore them"
423 fi
424
425 # **** Create the git tag ****
426
427 # convert according to DEP-14 rules
428 git_version=$(echo $version | tr ':~' '%_' | sed 's/\.(?=\.|$|lock$)/.#/g')
429
430 debian_tag="$distro/$git_version"
431 to_push+=("$debian_tag")
432
433 # If the user didn't supply a quilt mode, look for it in a previous
434 # tag made by this script
435 if [ "x$quilt_mode" = "x" ] && [ "$format" = "3.0 (quilt)" ]; then
436     set +o pipefail             # perl will SIGPIPE git-cat-file(1) here
437     if [ "x$last_debian_tag" != "x" ]; then
438         quilt_mode=$(git cat-file -p $(git rev-parse "$last_debian_tag") \
439                          | perl -wne \
440                                 'm/^\[dgit.*--quilt=([a-z+]+).*\]$/;
441                                  if ($1) { print "$1\n"; exit }')
442     fi
443     set -o pipefail
444 fi
445
446 quilt_mode_text=""
447 if [ "$format" = "3.0 (quilt)" ]; then
448     if [ "x$quilt_mode" = "x" ]; then
449         echo >&2 "$us: could not determine the git branch layout"
450         echo >&2 "$us: please supply a --quilt= argument"
451         exit 1
452     else
453         quilt_mode_text=" --quilt=$quilt_mode"
454     fi
455 fi
456
457 tagmessage="$source release $version for $target
458
459 [dgit distro=$distro split$quilt_mode_text]
460 [dgit please-upload$upstream_info]
461 "
462
463 git tag "${git_tag_opts[@]}" -s -m "$tagmessage" "$debian_tag" "$branch"
464
465 # **** Do a git push ****
466
467 if $pushing; then
468     git push "$remote" "${to_push[@]}"
469 fi